// watchdog.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>

#include "fsioctl.h"
#include "moxa\devices.h"

int _tmain(int argc, _TCHAR* argv[])
{
	DWORD dwTimer;

	// open the system service driver
	HANDLE hWdg = CreateFile( L"UCS1:", GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);

	dwTimer = 2000;
	// starts watchdog timer
	DeviceIoControl( hWdg, IOCTL_START_WDG, &dwTimer, sizeof(dwTimer), NULL, 0,  NULL, NULL);

	while ( TRUE )
	{
		printf( "Press \"ENTER\" in 5 seconds\n, 'q' to exit\n");
		WCHAR ch = getwchar();
		if ( ch == (WCHAR)'q' )
		{
			break;
		}

		// refresh watchdog timer
		DeviceIoControl( hWdg,  IOCTL_REFRESH_WDG, &dwTimer, sizeof(dwTimer), NULL, 0,  NULL, NULL);
		printf( "  *** fed *** \n");
	}

	// stops watchdog timer
	DeviceIoControl( hWdg, IOCTL_STOP_WDG, NULL, 0, NULL, 0,  NULL, NULL);

	// close the system service driver
	CloseHandle(hWdg);

	return 0;
}

